/*!
    @file  DATA_GEN.cpp
    @brief DATA_GEN Block Top

    Copyright (C) 2017 Fujitsu Limited. All rights reserved.
*/

#include "CDataGen.h"
#include "DATA_GEN.h"

/*! コンストラクタ
    @param param パラメータクラスへのポインタ 
*/
FUJITSU::DATA_GEN::DATA_GEN(boost::shared_ptr<C_param_wrap> param)
{
    m_algo = create(param);
}

boost::shared_ptr<AlgoBase>
FUJITSU::DATA_GEN::create(const boost::shared_ptr<C_param_wrap> param)
{
    bool error = false;
    boost::shared_ptr<Util_wrap> util = createUtil();
    boost::shared_ptr<AlgoBase> data_gen ;
    data_gen = boost::shared_ptr<AlgoBase>(new FUJITSU::CDataGen(param));
    
    if (error)
        return boost::shared_ptr<AlgoBase>();
    else
        return data_gen;
}
