/*!
    @file  DATA_GEN.h
    @brief DATA_GEN Block Top

    Copyright (C) 2017 Fujitsu Limited. All rights reserved.
*/

#ifndef DATA_GEN_H
#define DATA_GEN_H

#include "common_wrap.h"

namespace FUJITSU {

    /* DATA_GEN最上位クラス
    */
    class DATA_GEN : public OneBlockBase {
    public:
        DATA_GEN(boost::shared_ptr<C_param_wrap> param) ;
        virtual ~DATA_GEN() { ; }
        virtual void ReportStatisticalData(std::ostream& os, const double NowTime) {
            m_algo->ReportStatisticalData(os, NowTime);
        }
        virtual const std::string getVender() {
            return std::string("FUJITSU") ;
        }
        virtual const std::string getMakeTime() {
            return std::string(__DATE__) + std::string(" ") + std::string(__TIME__) ;
        }

        boost::shared_ptr<AlgoBase>
        create(const boost::shared_ptr<C_param_wrap> param);

    private:
    } ;
}

#endif
