/*!
    @file  DATA_GEN_wrap.cpp
    @brief DATA_GEN Block Wrapper

    Copyright (C) 2017 Fujitsu Limited. All rights reserved.
*/

#include <sstream>
#include "DATA_GEN_wrap.h"
/*  公開source */

/*  メンテナンス要 ここから */
#include <iostream>

DATA_GEN_wrap::DATA_GEN_wrap(boost::shared_ptr<C_param_wrap> param) {
    std::string str("DSP_DATA_GEN_Block");
    std::string block_name;
    param->getValue(str, &block_name, C_param_wrap::STRING);

    if (1) {
        m_blk = createDATA_GEN_FUJITSU(param) ;
    } else if (block_name == "FUJITSU") {
    } else if (block_name == "NTT") {
    } else {
        /*  error */
        std::stringstream msg ;
        msg << "DATA_GEN Block is not defined." ;
        g_err->appendMsg(msg.str()) ;
    }
}
/*  メンテナンス要 ここまで */

/*  以降メンテナンス不要 */
void DATA_GEN_wrap::ReportStatisticalData(std::ostream& os, const double NowTime) {
    m_blk->ReportStatisticalData(os, NowTime);
}
const std::string DATA_GEN_wrap::getVender() {
    return m_blk->getVender();
}
const std::string DATA_GEN_wrap::getMakeTime() {
    return m_blk->getMakeTime();
}
void DATA_GEN_wrap::Execute(std::vector<std::complex<double> >& OutputData) {
    m_blk->Execute(OutputData);
}

