/*!
    @file  DATA_GEN_wrap.h
    @brief DATA_GEN Block Wrapper

    Copyright (C) 2017 Fujitsu Limited. All rights reserved.
*/

#ifndef __DATA_GEN_WRAP_H__
#define __DATA_GEN_WRAP_H__

// 公開Header
#include <complex>
#include "common_wrap.h"
#include "ErrorMng_wrap.h"
#include <boost/shared_ptr.hpp>

/* メンテナンス要 ここから */
#include "createDATA_GEN_FUJITSU.h"
/* メンテナンス要 ここまで */

class DATA_GEN_wrap {
public:
    DATA_GEN_wrap() { ; }
    DATA_GEN_wrap(boost::shared_ptr<C_param_wrap> param);
    void ReportStatisticalData(std::ostream& os, const double NowTime);
    const std::string getVender();
    const std::string getMakeTime();
    void Execute(std::vector<std::complex<double> >& OutputData);
    
private:
    boost::shared_ptr<OneBlockBase> m_blk;
} ;

#endif  /* __DATA_GEN_WRAP_H__ */
