/*!
    @file  FFT.cpp
    @brief FFT Block Top

    Copyright (C) 2017 Fujitsu Limited. All rights reserved.
*/

#include "CFftWrap.h"
#include "FFT.h"

/*! コンストラクタ
    @param param パラメータクラスへのポインタ 
*/
FUJITSU::FFT::FFT(boost::shared_ptr<C_param_wrap> param)
{
    m_algo = create(param);
}

boost::shared_ptr<AlgoBase>
FUJITSU::FFT::create(const boost::shared_ptr<C_param_wrap> param)
{
    boost::shared_ptr<AlgoBase> fft ;
    fft = boost::shared_ptr<AlgoBase>(new FUJITSU::CFftWrap(param));
    return fft;
    
    /*
    bool error = false;
    boost::shared_ptr<Util_wrap> util = createUtil();
    std::string str("FFT_Algorithm");
    std::string algo_name;
    boost::shared_ptr<AlgoBase> fft ;

    if (util->checkAndGetParam(param, str, &algo_name, C_param_wrap::STRING)) {
        if (algo_name == "FFT") {
            fft = boost::shared_ptr<AlgoBase>(new FUJITSU::CFft(param));
        //} else if (algo_name == "FFT16_RADIX16") {
        } else {
            fft = boost::shared_ptr<AlgoBase>(new FUJITSU::CFftWrap(param));
        //} else {
            //g_err->appendMsg("FFT_Algorithm is invalid name");
            //error = true;
        }
    }

    
    if (error)
        return boost::shared_ptr<AlgoBase>();
    else
        return fft;
    */
}
