/*!
    @file  FFT.h
    @brief FFT Block Top

    Copyright (C) 2017 Fujitsu Limited. All rights reserved.
*/

#ifndef FFT_H
#define FFT_H

#include "common_wrap.h"

namespace FUJITSU {

    /* FFT最上位クラス
    */
    class FFT : public OneBlockBase {
    public:
        FFT(boost::shared_ptr<C_param_wrap> param) ;
        virtual ~FFT() { ; }
        virtual void ReportStatisticalData(std::ostream& os, const double NowTime) {
            m_algo->ReportStatisticalData(os, NowTime);
        }
        virtual const std::string getVender() {
            return std::string("FUJITSU") ;
        }
        virtual const std::string getMakeTime() {
            return std::string(__DATE__) + std::string(" ") + std::string(__TIME__) ;
        }

        boost::shared_ptr<AlgoBase>
        create(const boost::shared_ptr<C_param_wrap> param);

    private:
    } ;
}

#endif
