/*!
    @file  FFT_wrap.cpp
    @brief FFT Block Wrapper

    Copyright (C) 2017 Fujitsu Limited. All rights reserved.
*/

#include <sstream>
#include "FFT_wrap.h"
/*  公開source */

/*  メンテナンス要 ここから */
#include <iostream>

FFT_wrap::FFT_wrap(boost::shared_ptr<C_param_wrap> param) {
    std::string str("DSP_FFT_Block");
    std::string block_name;
    param->getValue(str, &block_name, C_param_wrap::STRING);

    if (1) {
        m_blk = createFFT_FUJITSU(param) ;
    } else if (block_name == "FUJITSU") {
    } else if (block_name == "NTT") {
    } else {
        /*  error */
        std::stringstream msg ;
        msg << "FFT Block is not defined." ;
        g_err->appendMsg(msg.str()) ;
    }
}
/*  メンテナンス要 ここまで */

/*  以降メンテナンス不要 */
void FFT_wrap::ReportStatisticalData(std::ostream& os, const double NowTime) {
    m_blk->ReportStatisticalData(os, NowTime);
}
const std::string FFT_wrap::getVender() {
    return m_blk->getVender();
}
const std::string FFT_wrap::getMakeTime() {
    return m_blk->getMakeTime();
}
void FFT_wrap::Execute(const std::vector<std::complex<double> >& InputData,
                       std::vector<std::complex<double> >& OutputData,
                       const bool ifft) {
    m_blk->Execute(InputData, OutputData, ifft);
}

