/*!
    @file  FFT_wrap.h
    @brief FFT Block Wrapper

    Copyright (C) 2017 Fujitsu Limited. All rights reserved.
*/

#ifndef __FFT_WRAP_H__
#define __FFT_WRAP_H__

// 公開Header
#include <complex>
#include "common_wrap.h"
#include "ErrorMng_wrap.h"
#include <boost/shared_ptr.hpp>

/* メンテナンス要 ここから */
#include "createFFT_FUJITSU.h"
/* メンテナンス要 ここまで */

class FFT_wrap {
public:
    FFT_wrap() { ; }
    FFT_wrap(boost::shared_ptr<C_param_wrap> param);
    void ReportStatisticalData(std::ostream& os, const double NowTime);
    const std::string getVender();
    const std::string getMakeTime();
    void Execute(const std::vector<std::complex<double> >& InputData,
                 std::vector<std::complex<double> >& OutputData,
                 const bool ifft);
    
private:
    boost::shared_ptr<OneBlockBase> m_blk;
} ;

#endif  /* __FFT_WRAP_H__ */
