/*!
    @file  C_SimTime.cpp
    @brief SIM時間クラス 

    @date     $Date:: 2016-01-28 13:10:50 #$
    @revision $Revision: 2 $

    Copyright (C) 2015 Fujitsu Limited. All rights reserved.
*/

#include "C_SimTime.h"
#include <limits.h>

/*---------------------------------------------------------------------------
**  1.日本語名 
**    コンストラクタ 
** 
**  2.パラメータ説明 
**    なし 
** 
**  3.概要 
**    シミュレーション時間クラスのオブジェクトを生成 
** 
**  4.機能説明 
** 
**  5.戻り値 
**    なし 
** 
**  6.備考 
*/
C_SimTime::C_SimTime()
: m_frame(0), m_tick(0)
{ ; }

C_SimTime::C_SimTime( int frame, int tick)
: m_frame(frame), m_tick(tick)
{}

C_SimTime::C_SimTime( const C_SimTime& tim)
: m_frame(tim.m_frame), m_tick(tim.m_tick)
{}

/*---------------------------------------------------------------------------
**  1.日本語名 
**    デストラクタ 
** 
**  2.パラメータ説明 
**    なし 
** 
**  3.概要 
**    シミュレーション時間クラスのオブジェクトを消滅 
** 
**  4.機能説明 
** 
**  5.戻り値 
**    なし 
** 
**  6.備考 
*/
C_SimTime::~C_SimTime()
{}

/*---------------------------------------------------------------------------
** スタティックメンバー変数 
*/
int C_SimTime::C_SIMTIME_TICK_PER_FRAME = INT_MAX;
