// ---------------------------------------------------------------------------
//  100G  Function MODEL $Name:  $
// ---------------------------------------------------------------------------
/*!
 *  @file
 *  $Id: error_test_error.cpp 2 2012-09-18 04:02:01Z kitajima $
 *  @brief エラー管理クラス(秘匿化部分)のテストコード
 */
// ---------------------------------------------------------------------------
// Copyright (c) FATEC Limited 2009
// ---------------------------------------------------------------------------
#include "ErrorMng_wrap.h"

/* [テスト内容] 
 * - Infoメッセージと、Warinigメッセージ、Errorメッセージを出力する場合に
 *   プログラム終了時の最大エラーコードがErrorとなる事を確認します。
 * - Errorメッセージを出力した後に、checkStatusを呼んだタイミングで
 *   システムが止まる事を確認します。
 */
 
boost::shared_ptr<ErrorMng_wrap> g_err = createErrorMng() ;

int main() {

  g_err->appendMsg("E message", ERROR_MSG) ;
  
  // WとIのメッセージが出力される事を確認
  g_err->appendMsg("W message", WARNING_MSG) ;
  g_err->appendMsg("I message", INFO_MSG) ;
  g_err->checkStatus() ;

  /*!
   * E messege を出力した後のcheckStatus()でシステムが止まるはずなので、
   * 下記coutの文字列が出力された場合、テストNGです。
   */
  std::cout << "*********************************" << std::endl ;
  std::cout << "* ErrorMng::checkStatus() is NG *" << std::endl ;
  std::cout << "*********************************" << std::endl ;
}

/*
  $Log: error_test_error.cpp,v $
  Revision 1.1.1.1  2009/09/26 07:59:49  nakayama
  initial import

*/
