// ---------------------------------------------------------------------------
//  100G  Function MODEL $Name:  $
// ---------------------------------------------------------------------------
/*!
 *  @file
 *  $Id: util_test.cpp 2 2012-09-18 04:02:01Z kitajima $
 *  @brief ユーティリティクラス(秘匿化部分)のテストコード
 */
// ---------------------------------------------------------------------------
// Copyright (c) FATEC Limited 2009
// ---------------------------------------------------------------------------
#include "I_Util.h"
#include <stdlib.h>

/* [テスト内容] 
 * - getVender() でVender名が取得できる事を確認します。
 * - getMakeDate() でアーカイブの作成日付が取得できる事を確認します。
 * - getDirName() でディレクトリ名が取得できることを確認します。
 * - getFileName() でファイル名が取得できることを確認します。
 * - outputProcessingTime() で実行時間を出力する事を確認します。
 */
 

int func(const char a, const char b) {
  return a < b ;
}

int main() {
  boost::shared_ptr<I_Util> util = createI_Util() ;
  
  std::cout << " vender    : " << util->getVender() << std::endl ;
  std::cout << " make time : " << util->getMakeTime() << std::endl ;
  
  std::cout << " dir name  : " << util->getDirName("/usr/bin/time") << std::endl ;
  std::cout << " file name : " << util->getFileName("/usr/bin/time") << std::endl ;
  
  size_t len = 20971520 ; //!< 20M
  char* tmp_array = new char[len] ;
  for (size_t idx = 0 ; idx < len ; ++idx) {
    tmp_array[idx] = rand() % 256 ;
  }
  qsort((void*)tmp_array, len, 1, (int (*)(const void*, const void*))func) ;
  delete [] tmp_array ;
  
  sleep(5) ; // 実時間とCPU TIMEをずらす為
  
  std::cout << "--------" << std::endl ;
  util->outputProcessingTime(std::cout) ; //! Prefix省略時
  std::cout << "--------" << std::endl ;
  util->outputProcessingTime(std::cout, "TEST") ; //! Prefix指定時
}


/*
  $Log: util_test.cpp,v $
  Revision 1.1.1.1  2009/09/26 07:59:49  nakayama
  initial import

*/
