#!/usr/bin/ruby

fft_point = ARGV[0].to_i
fft_radix = ARGV[1].to_i

out_file = "param_FFT" + ARGV[0] + "_RADIX" + ARGV[1] + ".txt"
fo = open(out_file, "w")

wave_num = fft_point / 2 -1

# サンプリング周波数122.88MHz固定
freq_base = 122880 / fft_point
freq = ""
for i in 1..wave_num
  freq = freq + (freq_base * i).to_s + ","
end
freq.sub!(/,$/, '')

offset = ""
for i in 1..wave_num
  offset = offset + "0,"
end
offset.sub!(/,$/, '')

amp = ""
for i in 1..wave_num
  #if (fft_point == 256)
  #  amp_f = i /512.0;
  if (fft_point >= 4096)
    amp_f = i /512.0;
  else
    amp_f = i
  end
  amp = amp + amp_f.to_s + ","
end

amp.sub!(/,$/, '')

fo.printf("<PARAM_FILE>\n")
fo.printf("WAVE_NUM                 : %d;\n", wave_num)
fo.printf("WAVE_FREQ                : %s;\n", freq)
fo.printf("WAVE_OFFSET              : %s;\n", offset)
fo.printf("WAVE_AMP                 : %s;\n", amp)
fo.printf("SAMPLING_FREQ            : 122.88;\n")
fo.printf("\n")
fo.printf("FFT_Algorithm            : FFT;\n")
fo.printf("FFT_POINT                : %d;\n", fft_point)
fo.printf("FFT_RADIX                : %d;\n", fft_radix)
fo.printf("\n")
fo.printf("FFT_IN_LOG               : ON;\n")
fo.printf("FFT_OUT_LOG              : ON;\n")
fo.printf("IFFT_IN_LOG              : ON;\n")
fo.printf("IFFT_OUT_LOG             : ON;\n")
fo.printf("FFT_IN_LOG_FILE_NAME     : fft_in_p%d_r%d.csv;\n", fft_point, fft_radix)
fo.printf("FFT_OUT_LOG_FILE_NAME    : fft_out_p%d_r%d.csv;\n", fft_point, fft_radix)
fo.printf("IFFT_IN_LOG_FILE_NAME    : ifft_in_p%d_r%d.csv;\n", fft_point, fft_radix)
fo.printf("IFFT_OUT_LOG_FILE_NAME   : ifft_out_p%d_r%d.csv;\n", fft_point, fft_radix)

# とりあえずの設定
fo.printf("FFT_PRECISION_W                  :  1, 32;\n")
fo.printf("FFT_PRECISION_IN                 : 13, 32;\n")
fo.printf("FFT_PRECISION_ST1_LP1            : 14, 32;\n")
#fo.printf("FFT_PRECISION_ST1_LP2_MLT_INDT   : 15, 32;\n")
#fo.printf("FFT_PRECISION_ST1_LP2_MLT_W      :  1, 32;\n")
fo.printf("FFT_PRECISION_ST1_LP2            : 15, 32;\n")
fo.printf("FFT_PRECISION_ST1_LP3            : 15, 32;\n")
fo.printf("FFT_PRECISION_ST1_LP4            : 15, 32;\n")
fo.printf("FFT_PRECISION_ST1_LP5            : 15, 32;\n")
fo.printf("FFT_PRECISION_ST1_LP6            : 15, 32;\n")
fo.printf("FFT_PRECISION_ST1_OUT            : 15, 32;\n")
fo.printf("FFT_PRECISION_ST2_LP1            : 15, 32;\n")
#fo.printf("FFT_PRECISION_ST2_LP2_MLT_INDT   : 15, 32;\n")
#fo.printf("FFT_PRECISION_ST2_LP2_MLT_W      :  1, 32;\n")
fo.printf("FFT_PRECISION_ST2_LP2            : 15, 32;\n")
fo.printf("FFT_PRECISION_ST2_LP3            : 15, 32;\n")
fo.printf("FFT_PRECISION_ST2_LP4            : 15, 32;\n")
fo.printf("FFT_PRECISION_ST2_LP5            : 15, 32;\n")
fo.printf("FFT_PRECISION_ST2_LP6            : 15, 32;\n")
fo.printf("FFT_PRECISION_OUT                : 11, 32;\n")
